<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.go(-1)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span v-if="routeFrom && routeFrom.name === 'Tasks'">
        Tâches
      </span>
      <span v-else>
        Données
      </span>
    </div>
    <div v-if="currentTask" class="task-detail">
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
      >
        <h2>
          Tâche {{ currentTask.task_id }}
        </h2>
        <div class="row g-2 align-items-center">
          <div class="col-4">
            Etat
          </div>
          <div
            class="col-8"
            :style="{color: currentTask.state === 'SUCCESS' ? 'green' : currentTask.state === 'FAILURE' ? 'red' : null }"
          >
            {{ currentTask.state }}
          </div>
        </div>
        <div
          v-if="currentTask.action"
          class="row g-2 align-items-center"
        >
          <div class="col-4">
            Action
          </div>
          <div
            class="col-8"
          >
            {{ currentTask.action }}
          </div>
        </div>
        <div
          v-if="currentTask.errors.length > 0"
          class="row g-2"
        >
          <div class="col-4">
            Erreur(s)
          </div>
          <div
            v-for="error of currentTask.errors"
            :key="error"
            class="col-8"
          >
            <pre class="pre-scrollable"><code>{{ error }}</code></pre>
          </div>
        </div>
        <div class="row g-2 align-items-center">
          <div class="col-4" style="margin-top: 2rem; font-weight: bold;">
            Chronologie
          </div>
        </div>
        <div
          v-for="step of currentTask.stack"
          :key="step.state"
          class="row g-2 align-items-center"
        >
          <div
            class="col-4"
            :style="{color: step.state === 'SUCCESS' ? 'green' : step.state === 'FAILURE' ? 'red' : null }">
            {{ step.state }}
          </div>
          <div class="col">
            {{
              new Date(step.datetime).toLocaleString('fr-FR', {
                year: "numeric",
                month: "long",
                day: "numeric",
                hour: '2-digit',
                minute: "2-digit",
                second: "2-digit"
              })
            }}
          </div>
        </div>
        <div v-if="currentTask.target_object && currentTask.target_object._model_name === 'dataset'">
          <div class="row g-2 align-items-center">
            <div class="col-4" style="margin-top: 2rem; font-weight: bold;">
              Jeu de données
            </div>
          </div>
          <div class="row g-2 align-items-center">
            <div class="row g-2 align-items-center">
              <div class="col">
                <router-link
                  :to="{ name: 'DatasetDetail', params: { id: currentTask.target_object.id }}"
                  custom
                  v-slot="{ navigate }"
                  class="custom-link"
                >
                  <span @click="navigate" role="link">
                    {{ currentTask.target_object.display_name }}
                  </span>
                </router-link>
              </div>
            </div>
          </div>
        </div>
      </b-overlay>
    </div>
  </div>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import RemoveFromGroup from '../../components/Modals/RemoveFromGroup.vue';

export default {
  components: { RemoveFromGroup },
  name: 'TaskDetail',

  data() {
    return {
      loading: null,
      routeFrom: null,
      loading: false,
    }
  },

  computed: {
    ...mapState('dashboard', [
      'currentTask'
    ]),
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
        vm.routeFrom = from;
    });
  },

  created() {
    this.loading = true;
    this.GET_TASK({ id: this.$route.params.id })
      .then(() => {
        this.loading = false;
      })
      .catch(() => {
        this.loading = false;
      });
  },

  mounted() {
    this.SET_RELOAD_INTERVAL_ID(setInterval(() => {
      this.updateTask();
    }, process.env.VUE_APP_RELOAD_INTERVAL));
  },

  methods: {
    ...mapMutations([
      'SET_RELOAD_INTERVAL_ID',
      'CLEAR_RELOAD_INTERVAL_ID'
    ]),
    ...mapActions('dashboard', [
      'GET_TASK'
    ]),

    updateTask() {
      if (!['SUCCESS', 'FAILURE'].includes(this.currentTask.state)) {
        this.loading = true;
        this.GET_TASK({ id: this.$route.params.id })
          .then(() => {
            if (['SUCCESS', 'FAILURE'].includes(this.currentTask.state)) {
              this.CLEAR_RELOAD_INTERVAL_ID();
            }
            this.loading = false;
          })
          .catch(() => {
            this.loading = false;
          });
      } else {
        this.CLEAR_RELOAD_INTERVAL_ID();
      }
    }
  }
}
</script>

<style lang="less" scoped>

.task-detail {
  max-width: 1000px;
  margin: 1rem auto;
}

.row {
  margin: 1rem 0;
  font-size: 1.2rem;
}

code {
  display: block;
  white-space: pre-wrap   
}

.custom-link {
  cursor: pointer;
  color: @blue;
}
.custom-link:hover {
  text-shadow: @blue 1px 0 1px;;
}

</style>
